<template>
  <div class="branch-selector" :class="{ isDeliveryPopup }">
    <transition name="branchSelector">
      <div class="branch-selector-box" v-show="current === STATUS.FORM">
        <close-button
          v-if="showCloseButton"
          class="close-button"
          :class="[$style.closeButton, isVipMember && $style.vipTheme]"
          @click="() => $emit('close-click')"
        />
        <div class="row align-items-center">
          <template v-if="!isDeliveryPopup">
            <div class="col-12 col-xl-4 align-self-start">
              <div class="branch-row">
                <h6
                  class="branch-selector-title mb-3"
                  :class="[$style.text, isVipMember && $style.vipTheme]"
                >
                  {{ $t("branchSelector.title") }}
                </h6>
                <div class="pt-xl-4 pb-xl-1"></div>

                <div class="row align-items-center">
                  <div class="col">
                    <selector
                      ref="branchSelector"
                      v-model="select.branch"
                      :options="branchOptions"
                      :z-index="3"
                      :placeholder="$t('placeholder.selectBranch')"
                    />
                  </div>
                  <div class="col-auto">
                    <button
                      class="skm-primary-btn"
                      :class="[$style.submit, isVipMember && $style.vipTheme]"
                      :disabled="!select.branch"
                      @click="submitBranch"
                    >
                      {{ $t("branchSelector.button.goNow") }}
                    </button>
                  </div>
                </div>
              </div>
            </div>

            <div class="col-12 col-xl-auto">
              <div class="pt-xl-3 pb-xl-4"></div>
              <div
                class="branch-selector-or"
                :class="[$style.text, isVipMember && $style.vipTheme]"
              >
                {{ $t("branchSelector.or") }}
              </div>
            </div>
          </template>

          <div class="col-12 col-xl">
            <div class="branch-row">
              <h6
                class="branch-selector-title mb-3"
                :class="[$style.text, isVipMember && $style.vipTheme]"
              >
                {{ $t(dynamicText.title) }}
              </h6>

              <div class="row align-items-center">
                <div class="col-12 col-md">
                  <div class="row">
                    <div class="col-12 col-md-6 mb-4">
                      <selector
                        ref="citySelector"
                        v-model="select.city"
                        :options="cityOptions"
                        :z-index="2"
                        :placeholder="$t('placeholder.selectCity')"
                      />
                      <div
                        class="text-danger error-message"
                        v-show="validator.touch && validator.city.error"
                      >
                        <i class="fa fa-exclamation-circle"></i>請選擇縣市
                      </div>
                    </div>
                    <div class="col-12 col-md-6 mb-4">
                      <selector
                        ref="areaSelector"
                        v-model="select.area"
                        :options="areaOptions"
                        :z-index="1"
                        :placeholder="$t('placeholder.selectArea')"
                      />
                      <div
                        class="text-danger error-message"
                        v-show="validator.touch && validator.area.error"
                      >
                        <i class="fa fa-exclamation-circle"></i>請選擇區域
                      </div>
                    </div>
                  </div>
                  <div class="row">
                    <div class="col-12 col-md-12 mb-4 mb-md-2">
                      <textarea
                        class="form-control form-control--new"
                        v-model="select.address"
                        type="text"
                        :placeholder="$t('placeholder.address')"
                      />
                      <div
                        class="text-danger error-message"
                        v-show="validator.touch && validator.address.error"
                      >
                        <i class="fa fa-exclamation-circle"></i>請輸入送餐地址
                      </div>
                    </div>
                  </div>
                </div>

                <div class="col-12 col-md-auto d-flex justify-content-end">
                  <button
                    class="skm-primary-btn"
                    :class="[$style.submit, isVipMember && $style.vipTheme]"
                    @click="submitFetchBranch"
                  >
                    {{ $t(dynamicText.button) }}
                  </button>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
    </transition>
    <transition name="searchResult" :duration="400">
      <div
        class="branch-selector-box result-box"
        v-show="current === STATUS.RESULT"
      >
        <div
          class="result-back"
          :class="[$style.text, isVipMember && $style.vipTheme]"
          @click="goBack"
        >
          <i class="ic-sm-arrow"></i>
          {{ $t("branchSelector.button.back") }}
        </div>

        <close-button
          v-if="showCloseButton"
          class="close-button"
          :class="[$style.closeButton, isVipMember && $style.vipTheme]"
          @click="() => $emit('close-click')"
        />

        <!-- 符合範圍，時間選擇 -->
        <div
          v-if="resultCurrent === RESULT_STATUS.TIME"
          class="row no-gutters result-content justify-content-center align-items-center w-100 mt-2"
          :class="{ isDeliveryPopup }"
        >
          <div class="col-12 text-center">
            <div class="py-3"></div>
            <img
              class="mb-3 mb-md-0"
              :src="
                `/static/images/location_ok_${isVipMember ? 'gold' : 'red'}.svg`
              "
              width="75"
              alt
            />
            <div class="mt-1">
              {{ $t("branchSelector.searchSelector.resultTitle2") }}
            </div>
            <div class="py-3"></div>
          </div>
          <div class="col-12">
            <div class="result-wrapper">
              <h6
                class="branch-selector-title mb-3"
                :class="[$style.text, isVipMember && $style.vipTheme]"
              >
                {{ $t("branchSelector.searchSelector.choose") }}
              </h6>
              <div class="time-error" v-show="selectTimeFirst">
                {{ $t("branchSelector.searchSelector.chooseTime") }}
              </div>
              <div class="section time" ref="timeSelector">
                <div class="section-content">
                  <dropdown
                    :class="{ 'dropdown-error': selectTimeFirst }"
                    @toggle="toggle"
                    :opened="open"
                    :value="
                      preorderTime && preorderDate
                        ? value
                        : $t('restaurant.preorderNotStarted')
                    "
                  />
                  <div class="mt-4" v-if="open">
                    <date-selector
                      @dateChanged="dateChanged"
                      @timeChanged="timeChanged"
                      @close="open = false"
                      :date="preorderDate"
                      :time="preorderTime"
                      :dates="preorderDates"
                      :times="preorderTimes"
                    />
                  </div>
                </div>
              </div>
              <div class="result-buttons mt-3">
                <button
                  class="skm-primary-btn mx-auto"
                  :class="[$style.submit, isVipMember && $style.vipTheme]"
                  @click="goToTabDelivery"
                >
                  {{ $t("branchSelector.button.goDelivery") }}
                  <i class="ic-sm-arrow ml-2"></i>
                </button>
              </div>
              <div class="py-3"></div>
            </div>
          </div>
        </div>

        <!-- 有結果，分館 -->
        <div
          v-if="resultCurrent === RESULT_STATUS.SEARCH"
          class="result-content w-100"
        >
          <div class="py-3"></div>
          <div class="row no-gutters justify-content-center align-items-center">
            <div class="col-md-auto text-center text-md-left">
              <span class="mr-2">{{
                $t("branchSelector.searchSelector.resultTitle")
              }}</span>
            </div>
            <div class="col-md-auto text-center text-md-left">
              <div class="pt-3 pt-md-0"></div>
              <div class="row result-buttons">
                <div
                  class="col-12 col-md-6"
                  v-for="(branch, index) in groupOptions"
                  :key="index"
                >
                  <router-link
                    class="skm-primary-btn mx-auto"
                    :class="[
                      $style.submit,
                      isVipMember && $style.vipTheme,
                      { 'mt-2': index > 0 },
                      { 'mt-md-0': index === 1 }
                    ]"
                    :to="`/groups/${branch.GroupId}`"
                    @click.native="
                      () => {
                        $emit('close-click');
                        $emit('check-scope', branch.GroupId);
                      }
                    "
                    >{{ branch.Title }} <i class="ic-sm-arrow ml-2"></i
                  ></router-link>
                </div>
              </div>
            </div>
          </div>
          <div class="py-3"></div>
        </div>

        <!-- 無結果，推薦分館 -->
        <div
          v-if="resultCurrent === RESULT_STATUS.RECOMMEND"
          class="result-content result-content--noResult w-100"
        >
          <div class="result-wrapper">
            <div class="py-3"></div>
            <div
              class="row no-gutters align-items-md-center justify-content-center"
            >
              <div class="col-12 text-center">
                <img
                  class="mb-3 mb-md-0"
                  :src="
                    `/static/images/location_error_${
                      isVipMember ? 'gold' : 'red'
                    }.svg`
                  "
                  width="75"
                  alt
                />
                <div class="text-left mt-3">
                  {{
                    $t(dynamicText.noResult, {
                      recommend: groupOptions.length
                        ? $t("branchSelector.searchSelector.resultHasRecommend")
                        : $t("branchSelector.searchSelector.resultNoRecommend")
                    })
                  }}
                </div>
              </div>

              <div class="col-12">
                <div class="pt-3"></div>
                <div class="row result-buttons justify-content-center">
                  <div
                    class="col-12 col-md-6"
                    v-for="(branch, index) in groupOptions"
                    :key="index"
                  >
                    <router-link
                      class="skm-primary-btn w-100"
                      :class="[
                        $style.submit,
                        isVipMember && $style.vipTheme,
                        { 'mt-2': index > 0 },
                        { 'mt-md-0': index === 1 }
                      ]"
                      :to="`/groups/${branch.GroupId}`"
                      @click.native="
                        () => {
                          $emit('close-click');
                          $emit('check-scope', branch.GroupId);
                        }
                      "
                      >{{ branch.Title }} <i class="ic-sm-arrow ml-2"></i
                    ></router-link>
                  </div>
                </div>
              </div>
            </div>
            <div class="py-3"></div>
          </div>
        </div>

        <!-- 無結果 -->
        <div
          v-if="resultCurrent === RESULT_STATUS.NO_RESULT"
          class="result-content result-content--noResult w-100"
        >
          <div class="result-wrapper">
            <div class="py-3"></div>
            <div
              class="row no-gutters align-items-md-center justify-content-center"
            >
              <div class="col-12 text-center">
                <img
                  class="mb-3 mb-md-0"
                  :src="
                    `/static/images/location_error_${
                      isVipMember ? 'gold' : 'red'
                    }.svg`
                  "
                  width="75"
                  alt
                />
                <div class="text-left mt-3">
                  {{
                    $t(dynamicText.noResult, {
                      recommend: groupOptions.length
                        ? $t("branchSelector.searchSelector.resultHasRecommend")
                        : $t("branchSelector.searchSelector.resultNoRecommend")
                    })
                  }}
                </div>
              </div>
            </div>
            <div class="py-3"></div>
          </div>
        </div>

        <!-- 無結果，其他服務 -->
        <div
          v-if="resultCurrent === RESULT_STATUS.SERVICE"
          class="result-content result-content--noResult w-100"
        >
          <div class="result-wrapper">
            <div class="py-3"></div>
            <div
              class="row no-gutters align-items-md-center justify-content-center"
            >
              <div class="col-12 text-center">
                <img
                  class="mb-3 mb-md-0"
                  :src="
                    `/static/images/location_error_${
                      isVipMember ? 'gold' : 'red'
                    }.svg`
                  "
                  width="75"
                  alt
                />
                <div class="text-left mt-3">
                  {{
                    $t(dynamicText.noResult, {
                      recommend: groupOptions.length
                        ? $t("branchSelector.searchSelector.resultHasRecommend")
                        : $t("branchSelector.searchSelector.resultNoRecommend")
                    })
                  }}
                </div>
              </div>
              <div
                class="col-12"
                v-if="$slots.otherService && showOtherService"
              >
                <div class="py-3"></div>
                <div class="mb-2">
                  {{ $t("branchSelector.searchSelector.otherService") }}:
                </div>
                <slot name="otherService" />
              </div>
            </div>
            <div class="py-3"></div>
          </div>
        </div>
      </div>
    </transition>
  </div>
</template>

<script>
import moment from "moment";
import capitalize from "lodash/capitalize";
import { mapState, mapActions, mapGetters, mapMutations } from "vuex";
import Selector from "@/components/Selector";
import CloseButton from "@/components/CloseButton";
import DateSelector from "@/components/Group/DateSelector";
import Dropdown from "@/components/Dropdown";
import * as groupPresenter from "@/presenters/group";

export const STATUS = {
  FORM: "form",
  RESULT: "result"
};

export const RESULT_STATUS = {
  TIME: "time",
  SEARCH: "search",
  RECOMMEND: "recommend",
  SERVICE: "service",
  NO_RESULT: "noResult"
};

const TEXT = {
  BRANCH: {
    title: "branchSelector.searchSelector.title",
    button: "branchSelector.button.checkBranch",
    noResult: "branchSelector.searchSelector.noResult"
  },
  DELIVER: {
    title: "branchSelector.searchSelector.deliverTitle",
    button: "branchSelector.button.confirm",
    noResult: "branchSelector.searchSelector.noResult2"
  }
};

export default {
  name: "BranchSelector",
  props: {
    showCloseButton: {
      type: Boolean,
      default: () => false
    },
    groupId: {
      type: String,
      default: () => ""
    }
  },
  data() {
    const { time, date } = this.$route.query;
    return {
      STATUS,
      RESULT_STATUS,
      showBranchSelector: true,
      fetchBranchTouch: false,
      fetchBranchValid: false,
      open: false,
      time: time,
      selectTimeFirst: false,
      date: date ? moment(date, "YYYY-MM-DD").toDate() : null
    };
  },
  components: {
    Selector,
    CloseButton,
    DateSelector,
    Dropdown
  },
  computed: {
    ...mapState("branch", [
      "current",
      "resultCurrent",
      "showSearchResult",
      "showRecommendResult",
      "showOtherService",
      "timesResult",
      "select",
      "isDeliveryPopup"
    ]),
    ...mapGetters("account", ["isVipMember"]),
    ...mapGetters("branch", [
      "areaOptions",
      "branchOptions",
      "cityOptions",
      "groupOptions"
    ]),
    ...mapState("location", ["lat", "lng"]),
    ...mapState("group", { fromGroup: "restaurants" }),
    ...mapState("restaurant", { fromRestaurant: "restaurant" }),

    restaurant() {
      if (Array.isArray(this.fromGroup) && this.fromGroup.length) {
        return this.fromGroup.find(
          item =>
            item.companyId === this.select.companyId &&
            item.id === this.select.id
        );
      } else {
        return this.fromRestaurant;
      }
    },

    preorderTime() {
      return this.time || "";
    },

    preorderDate() {
      return this.date || "";
    },

    preorderDates() {
      return groupPresenter.preorderDates();
    },

    preorderTimes() {
      const today = moment().format("YYYY-MM-DD");
      // 為了出現預設請選擇時間，this.date一開始為空字串會導致isToday判斷有問題
      // 假如一開始this.date空值時直接當成今天獲取times
      const isToday = this.date
        ? moment(this.date).format("YYYY-MM-DD") === today
        : true;

      return this.restaurant.preorderTimes(isToday);
    },

    dynamicText() {
      return this.isDeliveryPopup ? TEXT.DELIVER : TEXT.BRANCH;
    },

    validator() {
      const validate = {
        touch: this.fetchBranchTouch,
        city: {
          error: !this.select.city
        },
        area: {
          error: !this.select.area
        },
        address: {
          error: !this.select.address
        }
      };
      const isValid = Object.keys(validate).filter(
        key => validate[key]["error"]
      );
      return { ...validate, valid: isValid.length === 0 };
    },

    value() {
      return this.date && this.time
        ? groupPresenter.formatDate(this.date) + " " + this.time
        : "";
    }
  },
  mounted() {},
  methods: {
    ...mapActions({
      setBranch: "location/setBranch",
      getDeliveryBranches: "branch/getDeliveryBranches",
      checkBranchMatchDelivery: "branch/checkBranchMatchDelivery"
    }),
    ...mapMutations("branch", ["changeCurrent"]),
    goBack() {
      this.changeCurrent({
        current: STATUS.FORM,
        resultCurrent: this.resultCurrent
      });
      if (this.$route.query.date && this.$route.query.time) {
        this.$router.push({
          query: {}
        });
      }
    },
    submitFetchBranch() {
      this.fetchBranchTouch = true;
      if (this.validator.valid) {
        // 如果是外送
        if (this.isDeliveryPopup) {
          this.checkBranchMatchDelivery({
            companyId: this.select.companyId,
            groupId: this.groupId,
            lng: this.lng,
            lat: this.lat
          });
        } else {
          this.getDeliveryBranches({
            lng: this.lng,
            lat: this.lat,
            groupId: this.groupId
          });
        }
      }
    },
    submitBranch() {
      const { branch } = this.select;
      // 分店查詢
      if (this.branchOptions.find(option => option.value === branch)) {
        this.$router.push(`/groups/${branch}`);
        this.$emit("close-click");
        this.$emit("check-scope", branch);
      } else {
        // NOTE: handle here.
        console.log("invalid group id.");
      }
    },

    toggle() {
      this.open = !this.open;
    },

    dateChanged(date) {
      this.date = date;
      this.time = "";
      const newDate = moment(date).format("YYYY-MM-DD");
      if (this.$route.query.date !== newDate) {
        this.$router.push({
          query: {
            ...this.$route.query,
            date: newDate
          }
        });
      }
    },

    timeChanged(time) {
      this.time = time || "";
      if (this.$route.query.time !== time) {
        this.selectTimeFirst = false;
        this.$router.push({
          query: {
            ...this.$route.query,
            time
          }
        });
      }
    },

    tabLink(name) {
      const prefixName = "Restaurant";
      console.log({
        groupId: this.restaurant.groupId,
        companyId: this.select.companyId,
        id: this.restaurant.id
      });
      return {
        name: `${prefixName}${capitalize(name)}`,
        query: {
          time: this.preorderTime,
          date: moment(this.preorderDate).format("YYYY-MM-DD")
        },
        params: {
          groupId: this.restaurant.groupId,
          companyId: this.select.companyId,
          id: this.restaurant.id
        }
      };
    },
    goToTabDelivery() {
      const hasSelectedDate =
        this.preorderDates.filter(item => this.preorderDate === item).length >
        0;
      const hasSelectedTime =
        this.preorderTimes.filter(item => this.preorderTime === item).length >
        0;
      if (hasSelectedDate && hasSelectedTime) {
        this.$router.push(this.tabLink("delivery"));
        this.$emit("close-click");
        this.open = false;
      } else {
        this.selectTimeFirst = true;
      }
    }
  },
  updated() {
    if ((!this.time || !this.date) && this.select.companyId) {
      this.time = this.time || "";
      this.date = this.date || "";
    }
  }
};
</script>

<style lang="scss" scoped>
.branchSelector-enter-active {
  transition: all 0.4s ease-in-out;
}
.branchSelector-leave-active {
  transition: all 0.4s ease-in-out;
}
.branchSelector-enter, .branchSelector-leave-to
  /* .slide-fade-leave-active for below version 2.1.8 */ {
  transform: translate(0, 70px);
  opacity: 0;
}

.searchResult-enter-active {
  transition: all 0.4s ease-in-out;
}
.searchResult-leave-active {
  transition: all 0.4s ease-in-out;
}
.searchResult-enter, .searchResult-leave-to
  /* .slide-fade-leave-active for below version 2.1.8 */ {
  transform: translate(0, 70px);
  opacity: 0;
}

.branch-selector {
  position: relative;
  width: 100%;
  @include media-breakpoint-up(md) {
    max-width: 1070px;
  }

  &.isDeliveryPopup {
    @include media-breakpoint-up(md) {
      max-width: 830px;
    }

    .result-box {
      @include media-breakpoint-up(md) {
        height: auto;
        @media (max-height: 650px) {
          height: 500px;
          overflow: auto;
        }
      }
    }
  }

  &-title {
    color: $color-skm-red;
    font-size: 18px;
  }

  .dropdown-error {
    border-color: $color-skm-red;
  }

  .time-error {
    color: $color-skm-red;
    font-size: 14px;
  }

  &-or {
    margin: 20px auto;
    width: 30px;
    height: 30px;
    border-radius: 100%;
    background-color: #e1e2e2;
    color: $color-skm-red;
    padding: 7px;
    font-size: 12px;
    text-align: center;

    @include media-breakpoint-up(md) {
      padding: 3px;
      font-size: 16px;
    }
  }

  &-box {
    position: absolute;
    top: 0;
    left: 0;
    width: 100%;
    background-color: rgba($color-white, 0.95);
    display: block;
    box-shadow: none;
    padding: 20px 16px;

    @include media-breakpoint-up(md) {
      padding: 30px 24px;
      box-shadow: 0 4px 12px 0 rgba(0, 0, 0, 0.5);
      border-radius: 2px;

      div.label,
      div.space {
        display: none;
      }
    }

    div.action-row {
      height: 32px;
      width: 100%;
      margin: 20px 0px;
      display: inline-flex;
      flex-direction: row;
      justify-content: space-between;
      align-items: center;

      @include media-breakpoint-up(md) {
        padding: 0px 5px 0px 5px;
        height: 22px;
        width: 100%;
        margin: 12px 0px;
      }
      div.label {
        position: relative;
        color: $color-primary-black;
        padding-left: 42px;
        cursor: default;

        &:before {
          position: absolute;
          display: block;
          top: -2px;
          left: 0px;
          content: "";
          width: 32px;
          height: 32px;
          background-image: url("/static/images/landing-page-button.svg");
          background-repeat: no-repeat;
          background-size: 96px 160px;
          .theme-vip-member & {
            background-position-y: -64px;
          }
        }

        &.label-preordering {
          &:before {
            background-position: -32px 0px;
            .theme-vip-member & {
              background-position-y: -64px;
            }
          }
        }
      }
      div.space {
        display: block;
        width: 1px;
        flex-grow: 1;
      }
      div.btn-back {
        color: $color-skm-red;
        margin: 12px 4px 12px 0px;
        cursor: pointer;

        @include media-breakpoint-up(md) {
          i.ic-sm-arrow {
            display: inline-block;
          }
          span.label-back {
            display: inline;
          }
          span.label-change {
            display: none;
          }
        }

        .theme-vip-member & {
          color: $color-skm-gold;
        }

        i.ic-sm-arrow {
          font-size: 0.615em;
          transition: transform 0.3s;
          display: none;
          transform-origin: center 0.5em;
          transform: rotate(90deg);
        }
        span.label-back {
          display: none;
        }
        span.label-change {
          display: inline;
        }
      }
    }
  }

  .form-control {
    max-width: none;
  }
}

.result {
  &-box {
    position: absolute;
    top: 0;
    left: 0;
    z-index: 5;
    display: flex;
    align-items: center;
    width: 100%;

    background-color: rgba($color-white, 0.95);
    color: $color-secondary-black;
    padding: 20px;

    @include media-breakpoint-up(md) {
      width: 830px;
      left: 50%;
      margin-left: -415px;
    }
  }

  &-back {
    cursor: pointer;
    position: absolute;
    z-index: 5;
    top: 22px;
    left: 22px;
    display: inline-flex;
    align-items: center;
    color: $color-skm-red;

    .ic-sm-arrow {
      margin-right: 10px;
      &:before {
        transform: rotate(90deg);
      }
    }
  }

  &-content {
    font-size: 18px;

    .skm-primary-btn {
      display: flex;
      align-items: center;
      justify-content: center;
      width: 260px;
      height: 50px;
      font-size: 20px;
      padding-left: 16px;
      border-radius: 2px;

      .ic-sm-arrow {
        display: inline-block;
        margin-right: 10px;
        &:before {
          transform: rotate(-90deg);
        }
      }
    }
    &--noResult {
      // padding: 16% 0;
      @include media-breakpoint-up(md) {
        // padding: 0 4% 0 14%;
        min-height: auto;
      }
    }

    &.isDeliveryPopup {
      .skm-primary-btn {
        width: 100%;
        @include media-breakpoint-up(md) {
          width: 260px;
        }
      }
    }
  }

  &-buttons {
    @include media-breakpoint-up(md) {
      max-width: 560px;
    }
  }

  &-wrapper {
    max-width: 530px;
    margin: 0 auto;
  }
}

.ic-sm-arrow {
  display: flex;
  font-size: 13px;
  line-height: 0;
  &:before {
    display: inline-block;
  }
}

.error-message {
  position: absolute;
  font-size: 13px;
  padding: 4px 0 0;

  i {
    font-size: 15px;
    margin-right: 5px;
  }
}

.close-button {
  position: absolute;
  z-index: 1;
  right: 16px;
  top: 16px;
  background-color: transparent;
  border: 1px $color-skm-red solid;

  &:before,
  &:after {
    background: $color-skm-red;
    width: 20px;
    margin-left: -10px;
    margin-top: 0px;
  }
}

.deliver-picker {
  margin-bottom: 0.75em;
  .picker-control {
    font-size: 14px;
    line-height: 28px;
    height: 38px;
  }
}

.slot-list {
  flex-flow: row wrap;
  margin: 0 -5px;

  @include media-breakpoint-up(md) {
    margin: 0 -8px;
  }
}

.slot-item {
  flex: 0 1 25%;
  padding: 0 5px 10px 5px;

  @include media-breakpoint-up(md) {
    flex: 0 1 20%;
    padding: 0 8px 16px 8px;
  }
  @include media-breakpoint-up(lg) {
    flex: 0 1 16.66%;
  }
}

.slot-btn {
  border-radius: 2px;
  border: 1px solid $color-silver-grey;
  color: $color-secondary-black;
  line-height: 36px;
  appearance: none;
  padding: 0;
  display: block;
  background-color: $color-white;
  width: 100%;
  cursor: pointer;
  font-size: 13px;

  .slot-item--active & {
    background-color: $color-skm-red;
    border-color: $color-skm-red;
    color: $color-white;
  }

  .slot-item--disabled & {
    pointer-events: none;
    border-color: $color-mineral-ice;
    background-color: $color-mineral-ice;
    color: $color-silver-grey;
  }

  @include media-breakpoint-up(md) {
    line-height: 25px;
  }
}

::v-deep {
  .date-selector {
    .tags.scroll {
      &:after {
        background: none;
      }
    }
  }
}
</style>

<style lang="scss" module>
:global(.branch-selector) {
  .submit {
    background: $color-skm-red;
  }
  textarea {
    &::placeholder {
      color: $color-silver-grey;
    }
  }

  .vipTheme {
    &.text {
      color: $color-skm-gold;
    }
    &.select {
      li {
        &.isActive {
          background: $color-skm-gold;
        }
      }
    }

    &.submit,
    &.isOpened {
      background: $color-skm-gold;
    }
    &.closeButton {
      border-color: $color-skm-gold;
      &:before,
      &:after {
        background: $color-skm-gold;
      }
    }
  }
}
</style>
